/*
Copyright 2004  Sukru Cinar

This file is part of rxsheyi.

rxsheyi is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

rxsheyi is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with rxsheyi; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "option.h"

static int mode= 'P';
/*	'P'	 for parse
	'H'  for help
	'X'  for pass args (after --)
*/

void parse_options(int argc,char **argv);

static int option_help(int argc,char **argv, char *fmt, ... ) {
	va_list ap;
	va_start(ap,fmt);
	fprintf(stderr,"%s: ",argv[0]);
	vfprintf(stderr,fmt, ap);
	fprintf(stderr,"\n");
	va_end(ap);
	fprintf(stderr,"command line options:\n");
	mode='H';
	parse_options(argc,argv);
	return 1;
}

int option(int argc,char **argv,int *ndx,char *name,int argtype,char *help, char** Rstr, int *Rint) {
	char *R;
	if (mode=='H') {
		fprintf(stderr,"\t%s\t%s\n",name,help);
		return 0;
	}
	if (mode=='X')
		return 0;
	if (strncmp(argv[*ndx],name,strlen(name)))
		return 0;
	if (argtype==ARG_NONE)
		return 1;
	if (strlen(argv[*ndx])==strlen(name)) {
		(*ndx)++;
		if (*ndx==argc)
			option_help(argc,argv,"you need to give an argument to option %s",name);
		R= argv[*ndx];
	} else {
		R= argv[*ndx]+strlen(name);
	}
	if (argtype==ARG_INT) {
		char *x;
		*Rint= strtol(R,&x,0);
		if (x==R)
			option_help(argc,argv,"you need to give an integer argument to option %s. given: %s",name,R);
	} else *Rstr= R;
	return 1;
}

int option_dashdash(int argc,char **argv,int ndx) {
	if (mode!='P')
		return 0;
	if (!strcmp(argv[ndx],"--")) {
		mode= 'X';
		return 1;
	}
	return 0;
}

int option_isarg(int argc,char **argv,int ndx,char **arg) {
	if (mode=='H')
		return 0;
	if (mode=='X' || argv[ndx][0]!='-') {
		*arg= argv[ndx];
		return 1;
	}
	return 0;
}

int option_endoflist(int argc,char **argv,int ndx) {
	if (mode=='H')
		exit(1);
	option_help(argc,argv,"unknown option or argument %s",argv[ndx]);
	return 1;
}
