/*
Copyright 2004  Sukru Cinar

This file is part of rxsheyi.

rxsheyi is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

rxsheyi is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with rxsheyi; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
strchar  ([^"\\]|(\\.))
IDBEGIN  [A-Za-z_]
ID       [A-Za-z_0-9]
WS       [ \t\r\n\v\b\f]
%x oneof
%x modmod
%option noyywrap nounput yylineno
%{
static int translate_coded(char *x) {
	unsigned char *a= x;
	return a[0]*8*8 + a[1]*8 + a[2];
}

static int translate_escape(int x) {
	switch(x) {
	case 'r': return '\r';
	case 'n': return '\n';
	case 'b': return '\b';
	case 'v': return '\v';
	case 'f': return '\f';
	case 't': return '\t';
	case 'e': return 0x33;
	case 's': return ' ';
	default:
		return x;
	}
}
%}
%%
"oneof"  { BEGIN(oneof); return ONEOF; }
<oneof>; { BEGIN(0); return ';';  }
<oneof>{WS}+  { }
<oneof>\\[0-7][0-7][0-7] {yylval.ch= translate_coded(yytext+1); return CHAR; }
<oneof>\\.  { yylval.ch= translate_escape(yytext[1]); return CHAR; }
<oneof>. {  yylval.ch= yytext[0]; return CHAR; }
{IDBEGIN}{ID}*  { yylval.token= strdup(yytext); return IDENTIFIER; }
[0-9][0-9]*     { yylval.token= strdup(yytext); return NUMBER; }
"*" |
"?" |
"|" |
"+" | 
"(" | 
")" | 
"," |
"[" |
"]" |
":" |
"." |
";"  {  return yytext[0]; }
\"{strchar}+\" { yylval.token= strdup(yytext); return STRING_LITERAL; }
"%%"  { BEGIN(modmod); return MODMOD; }
<modmod>. { yylval.ch= yytext[0]; return XCHAR; }
<modmod>\n { yylval.ch= yytext[0]; return XCHAR; }
{WS}+ { }
.   { }
%%
