/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     NUMBER = 259,
     STRING_LITERAL = 260,
     CHAR = 261,
     XCHAR = 262,
     ONEOF = 263,
     MODMOD = 264
   };
#endif
#define IDENTIFIER 258
#define NUMBER 259
#define STRING_LITERAL 260
#define CHAR 261
#define XCHAR 262
#define ONEOF 263
#define MODMOD 264




/* Copy the first part of user declarations.  */
#line 20 "rxsheyi.y"

#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <sys/stat.h>
#include "option.h"

char *prgname;

typedef unsigned char uint8;

typedef struct expression_s {
	struct expression_s *prev,*next;
	int opcode;
	void *data; /* for stuff that read from external world */
	struct expression_s *first;
} expression_t;

#define for_children(a,b) \
do {\
	expression_t *b; \
	b= a->first; \
	if (b) \
		do {

#define end_for(a,b) \
			b=b->next; \
		} while(b!=a->first);\
} while(0)


typedef struct {
        int len,size;
        uint8 *data;
} cbuffer_t;

cbuffer_t *rest;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 61 "rxsheyi.y"
typedef union YYSTYPE {
	char *token;
	char ch;
	int dummy;
	cbuffer_t *cbuffer;
	expression_t *expression;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 143 "rxsheyi.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */
#line 75 "rxsheyi.y"


#define CLL_INSERT_BEFORE(x,y) do { \
                (y)->prev= (x)->prev; \
                (y)->next= (x); \
                (x)->prev->next= (y); \
                (x)->prev= (y); \
} while(0)


#define CLL_REMOVE(__ll_x) do { \
        (__ll_x)->prev->next= (__ll_x)->next; \
        (__ll_x)->next->prev= (__ll_x)->prev; \
} while(0)


static expression_t *new_expression() {
	expression_t *e= malloc(sizeof(*e));
	e->prev= e->next= e;
	e->first= 0;
	return e;
}

static expression_t *make_leaf(int code, void *data) {
	expression_t *e= new_expression();
	e->opcode= code;
	e->data= data;
	return e;
}

static expression_t* make_operator(int code, expression_t *sub, ... ) {
	expression_t *e= new_expression();
	e->opcode= code;
	if (sub) {
		va_list ap;
		e->first= sub;
		va_start(ap,sub);
		while((sub=va_arg(ap,expression_t*))) 
			CLL_INSERT_BEFORE(e->first,sub);
		va_end(ap);
	}
	return e;
}

static expression_t *expression_copy(expression_t *e) {
	expression_t *n= new_expression();
	n->opcode= e->opcode;
	n->data= e->data;
	if (e->first) {
		expression_t *c;
		c= e->first;
		do {
			expression_t *tc= expression_copy(c);
			if (n->first)
				CLL_INSERT_BEFORE(n->first,tc);
			else
				n->first= tc;
			c= c->next;
		} while(c!=e->first);
	}
	return n;
}

void cbuffer_init(cbuffer_t *cb) {
        cb->data= 0;
        cb->size= 0;
        cb->len= 0;
}

int cbuffer_append(cbuffer_t *cb,const uint8 *b,int len) {
        if (!len)
                return 0;
        if (cb->len+len>cb->size) {
                int ns= 1024;
                while(ns< (cb->len+len))
                        ns= ns+ ns/2;
                void *np= realloc(cb->data, ns);
                if (!np)
                        return 1;
                cb->data= np;
                cb->size= ns;
        }
        memcpy(cb->data+cb->len, b, len);
        cb->len+= len;
        return 0;
}

int cbuffer_appendc(cbuffer_t *cb,int x) {
	uint8 a= x;
	return cbuffer_append(cb, &a,1);
}

void cbuffer_uninit(cbuffer_t *cb) {
        if (cb->data)
                free(cb->data);
        cbuffer_init(cb);
}

typedef struct rule_s {
	struct rule_s *prev,*next;
	char *name;
	expression_t *definition;
} rule_t;

static rule_t head= { &head, &head };

static rule_t *find_rule(char *name) {
	rule_t *r;
	for (r=head.next;r!=&head;r=r->next)
		if (!strcmp(name,r->name))
			return r;
	return 0;
}

static void add_rule(char *name,expression_t *def) {
	rule_t *r= find_rule(name);
	if (r) {
		r->definition= make_operator('|' , r->definition, def, 0 );
	} else {
		r= malloc(sizeof(*r));
		r->name= name;
		r->definition= def;
		CLL_INSERT_BEFORE(&head,r);
	}
}

static void do_directive(char *name, expression_t *args);


int yylex();
static void yyerror(char *msg);


/* Line 214 of yacc.c.  */
#line 287 "rxsheyi.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  10
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   49

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  22
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  16
/* YYNRULES -- Number of rules. */
#define YYNRULES  32
/* YYNRULES -- Number of states. */
#define YYNSTATES  50

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   264

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      16,    17,    13,    15,    20,     2,    21,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    10,    11,
       2,     2,     2,    14,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    18,     2,    19,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    12,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     7,     9,    12,    14,    16,    18,    23,
      25,    27,    30,    33,    35,    39,    41,    44,    46,    49,
      52,    55,    57,    61,    63,    65,    70,    74,    76,    78,
      80,    87,    90
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      23,     0,    -1,    24,     9,    37,    -1,    24,    -1,    24,
      25,    -1,    25,    -1,    26,    -1,    36,    -1,    27,    10,
      28,    11,    -1,     3,    -1,    30,    -1,     8,    29,    -1,
      29,     6,    -1,     6,    -1,    30,    12,    31,    -1,    31,
      -1,    31,    32,    -1,    32,    -1,    32,    13,    -1,    32,
      14,    -1,    32,    15,    -1,    33,    -1,    16,    30,    17,
      -1,     3,    -1,     5,    -1,     3,    18,    34,    19,    -1,
      34,    20,    35,    -1,    35,    -1,    28,    -1,     4,    -1,
      21,    27,    18,    34,    19,    11,    -1,    37,     7,    -1,
       7,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   208,   208,   209,   210,   211,   212,   213,   215,   220,
     221,   222,   224,   228,   235,   236,   238,   239,   241,   242,
     243,   244,   245,   246,   247,   249,   250,   251,   253,   254,
     256,   260,   265
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "NUMBER", "STRING_LITERAL", 
  "CHAR", "XCHAR", "ONEOF", "MODMOD", "':'", "';'", "'|'", "'*'", "'?'", 
  "'+'", "'('", "')'", "'['", "']'", "','", "'.'", "$accept", 
  "everything", "file", "element", "rule", "name", "definition", 
  "charlist", "subdefinition", "alternative", "factor", "funcexpr", 
  "arglist", "arg", "directive", "rest", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      58,    59,   124,    42,    63,    43,    40,    41,    91,    93,
      44,    46
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    22,    23,    23,    24,    24,    25,    25,    26,    27,
      28,    28,    29,    29,    30,    30,    31,    31,    32,    32,
      32,    32,    32,    32,    32,    33,    34,    34,    35,    35,
      36,    37,    37
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     1,     2,     1,     1,     1,     4,     1,
       1,     2,     2,     1,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     1,     4,     3,     1,     1,     1,
       6,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     9,     0,     0,     3,     5,     6,     0,     7,     0,
       1,     0,     4,     0,     0,    32,     2,    23,    24,     0,
       0,     0,    10,    15,    17,    21,    29,    28,     0,    27,
      31,     0,    13,    11,     0,     8,     0,    16,    18,    19,
      20,     0,     0,     0,    12,    22,    14,    30,    26,    25
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     3,     4,     5,     6,     7,    27,    33,    22,    23,
      24,    25,    28,    29,     8,    16
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -24
static const yysigned_char yypact[] =
{
      -1,   -24,     3,    18,    -2,   -24,   -24,     2,   -24,    -8,
     -24,    28,   -24,     6,     0,   -24,    29,     7,   -24,    11,
      10,    26,     9,    10,    17,   -24,   -24,   -24,     8,   -24,
     -24,     0,   -24,    32,    12,   -24,    10,    17,   -24,   -24,
     -24,    30,     0,    14,   -24,   -24,    10,   -24,   -24,   -24
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -24,   -24,   -24,    35,   -24,    38,    31,   -24,    22,    13,
     -23,   -24,    15,     1,   -24,   -24
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      37,     1,     1,    17,    26,    18,     1,    11,    19,    17,
      14,    18,    13,    17,    19,    18,    20,    32,    10,     2,
       2,    36,    20,    37,    36,    31,    20,    41,    42,    45,
      38,    39,    40,    49,    42,    15,    30,    35,    44,    12,
       9,    47,    34,    48,    21,     0,    43,     0,     0,    46
};

static const yysigned_char yycheck[] =
{
      23,     3,     3,     3,     4,     5,     3,     9,     8,     3,
      18,     5,    10,     3,     8,     5,    16,     6,     0,    21,
      21,    12,    16,    46,    12,    18,    16,    19,    20,    17,
      13,    14,    15,    19,    20,     7,     7,    11,     6,     4,
       2,    11,    20,    42,    13,    -1,    31,    -1,    -1,    36
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    21,    23,    24,    25,    26,    27,    36,    27,
       0,     9,    25,    10,    18,     7,    37,     3,     5,     8,
      16,    28,    30,    31,    32,    33,     4,    28,    34,    35,
       7,    18,     6,    29,    30,    11,    12,    32,    13,    14,
      15,    19,    20,    34,     6,    17,    31,    11,    35,    19
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 208 "rxsheyi.y"
    { rest= yyvsp[0].cbuffer; yyval.dummy=yyvsp[-2].dummy; ;}
    break;

  case 6:
#line 212 "rxsheyi.y"
    { yyval.dummy= 0; ;}
    break;

  case 7:
#line 213 "rxsheyi.y"
    { yyval.dummy=0; ;}
    break;

  case 8:
#line 215 "rxsheyi.y"
    {
	add_rule(yyvsp[-3].token,yyvsp[-1].expression);
	yyval.dummy= 0;
;}
    break;

  case 11:
#line 222 "rxsheyi.y"
    { yyval.expression=make_leaf('O', yyvsp[0].cbuffer); ;}
    break;

  case 12:
#line 224 "rxsheyi.y"
    {
	cbuffer_appendc(yyvsp[-1].cbuffer, yyvsp[0].ch);
	yyval.cbuffer= yyvsp[-1].cbuffer;
;}
    break;

  case 13:
#line 228 "rxsheyi.y"
    {
	cbuffer_t *b= malloc(sizeof(*b));
	cbuffer_init(b);
	cbuffer_appendc(b, yyvsp[0].ch);
	yyval.cbuffer=b;
;}
    break;

  case 14:
#line 235 "rxsheyi.y"
    { yyval.expression= make_operator( '|' , yyvsp[-2].expression, yyvsp[0].expression, 0 ); ;}
    break;

  case 16:
#line 238 "rxsheyi.y"
    { yyval.expression= make_operator('.', yyvsp[-1].expression, yyvsp[0].expression, 0 ); ;}
    break;

  case 18:
#line 241 "rxsheyi.y"
    { yyval.expression= make_operator( '*', yyvsp[-1].expression, 0); ;}
    break;

  case 19:
#line 242 "rxsheyi.y"
    { yyval.expression= make_operator( '?', yyvsp[-1].expression, 0); ;}
    break;

  case 20:
#line 243 "rxsheyi.y"
    { yyval.expression= make_operator( '+', yyvsp[-1].expression, 0); ;}
    break;

  case 22:
#line 245 "rxsheyi.y"
    { yyval.expression=yyvsp[-1].expression; ;}
    break;

  case 23:
#line 246 "rxsheyi.y"
    { yyval.expression=make_leaf( 'I', yyvsp[0].token); ;}
    break;

  case 24:
#line 247 "rxsheyi.y"
    { yyval.expression= make_leaf( 'S', yyvsp[0].token); ;}
    break;

  case 25:
#line 249 "rxsheyi.y"
    { yyval.expression=make_operator('[', make_leaf( 'I', yyvsp[-3].token), yyvsp[-1].expression,0); ;}
    break;

  case 26:
#line 250 "rxsheyi.y"
    { yyval.expression= make_operator(',' , yyvsp[-2].expression, yyvsp[0].expression,0); ;}
    break;

  case 29:
#line 254 "rxsheyi.y"
    { yyval.expression= make_leaf( 'N', yyvsp[0].token ); ;}
    break;

  case 30:
#line 256 "rxsheyi.y"
    {
	do_directive(yyvsp[-4].token,yyvsp[-2].expression);
;}
    break;

  case 31:
#line 260 "rxsheyi.y"
    {
	cbuffer_appendc(yyvsp[-1].cbuffer,yyvsp[0].ch);
	yyval.cbuffer= yyvsp[-1].cbuffer;
;}
    break;

  case 32:
#line 265 "rxsheyi.y"
    {
	cbuffer_t *b= malloc(sizeof(cbuffer_t));
	cbuffer_init(b);
	cbuffer_appendc(b, yyvsp[0].ch);
	yyval.cbuffer= b;
;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1324 "rxsheyi.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 272 "rxsheyi.y"


#include "lex.yy.c"

static void yyerror(char *msg) {
	fprintf(stderr,"near line %d: %s\n",yylineno,msg);
	exit(1);
}

static FILE* output_file;

static int oprintf(char *fmt, ... ) {
	va_list ap;
	int ret;
	va_start(ap,fmt);
	ret= vfprintf(output_file, fmt, ap);
	va_end(ap);
	return ret;
}

static char *encode_char(int x) {
	static char buf[10];
	if (x<32 || x>126)
		sprintf(buf,"\\%03o",x);
	else if (x!='\\')
		sprintf(buf,"%c",x);
	else
		sprintf(buf,"\\\\");
	return buf;
}

static void print_code( expression_t *expr );

static void print_op(expression_t *e,char *fn,int trailing_zero) {
	expression_t *c;
	oprintf("%s(",fn);
	c= e->first;
	if (c)
		do {
			if (c!=e->first)
				oprintf(",");
			print_code(c);
			c= c->next;
		} while(c!=e->first);
	if (trailing_zero)
		oprintf(",0");
	oprintf(")");
}

static int builtin_operator(char *n) {
	static char * bi[]= {
		"Except", "Range", "Save",
		0
	};
	int i;
	for(i=0;bi[i];i++)
		if (!strcmp(n,bi[i]))
			return 1;
	return 0;
}

static void print_code( expression_t *expr ) {
	switch( expr->opcode ) {
		case '.': print_op(expr,"Cat",0); break;
		case '|': print_op(expr, "Or" ,0); break;
		case '?': print_op(expr, "Opt",0); break;
		case '+': print_op(expr, "Plus",0); break;
		case '*': print_op(expr, "Star",0); break;
		case '[': {
				expression_t *i= expr->first;
				expr->first= expr->first->next;
				CLL_REMOVE(i);
				print_op(expr, i->data, !builtin_operator(i->data));
				CLL_INSERT_BEFORE(expr->first,i);
				expr->first= i;
			}
			break;
		case ',':
			print_code(expr->first);
			oprintf(",");
			print_code(expr->first->next);
			break;
		case 'S':
			oprintf("Str(%s)", (char*) expr->data);
			break;
		case 'I':
			oprintf("__generate__%s()", (char*) expr->data);
			break;
		case 'N':
			oprintf("Number(%s)",(char*)  expr->data);
			break;
		case 'O': {
			int i;
			cbuffer_t *cb;
			oprintf("OneOf(");
			cb=expr->data;
			for(i=0;i<cb->len;i++)
				oprintf("'%s', ", encode_char(cb->data[i]));
			oprintf("-1)");
			break;
		}
	}
}

static void print_rule(rule_t *r) {
	oprintf("t __generate__%s() {\n\t return ",r->name);
	print_code(r->definition);
	oprintf(";\n}\n");
}

static void print_all_rules() {
	rule_t *r;
	for(r=head.next;r!=&head;r=r->next)
		print_rule(r);
}


static expression_t po[]= {
	{ 0, 0, 0, 0 },
	{ 0, 0, 0, "Star", 0 },
	{ 0, 0, 0, "Plus", 0 },
	{ 0, 0, 0, "Opt", 0 },
	{ 0, 0, 0, "Or", 0 },
	{ 0, 0, 0, "Cat", 0 },
	{ 0, 0, 0, "Save", 0},
	{ 0, 0, 0, "Range", 0 },
	{ 0, 0, 0, "Except", 0 },
};

void print_operator_prototypes(expression_t* x) {
	for_children(x,c)
		print_operator_prototypes(c);
	end_for(x,c);
	if (x->opcode=='[') {
		char *y= x->first->data;
		if (!po[0].prev) {
			int i;
			int sz= sizeof(po)/sizeof(po[0]);
			for(i=0;i<sz;i++) {
				po[i].prev= po+(i+sz-1)%sz;
				po[i].next= po+(i+1)%sz;
			}
		} 
		for(x=po+1;x!=po;x=x->next)
			if (!strcmp(y,x->data))
				return ;
		x= new_expression();
		x->data= y;
		CLL_INSERT_BEFORE(po, x);
		oprintf( "t %s(t x, ... );\n",y); 
	}
}

static void print_prototypes() {
	rule_t *r;
	for(r=head.next;r!=&head;r=r->next)
		oprintf("t __generate__%s();\n",r->name);
	for(r=head.next;r!=&head;r=r->next)
		print_operator_prototypes(r->definition);
}


static expression_t toplevels= { &toplevels, &toplevels };

static expression_t *getarg(expression_t *t,int x,int *y) {
	if (t->opcode!=',') {
		if (*y==x)
			return t;
		(*y)++;
		return NULL;
	} else {
		expression_t *left= getarg(t->first, x, y);
		if (left)
			return left;
		return getarg(t->first->next,x,y);
	}
}

static expression_t *arg(expression_t *args,int i) {
	int x=0;
	return getarg(args,i,&x);
}

static void do_generate(expression_t *args) {
	expression_t *a[3];
	int i;
	for(i=0;i<3;i++) a[i]= arg(args,i);
	if (a[0]->opcode!='I' || a[1]->opcode!='S' || a[2]->opcode!='S')
		exit(fprintf(stderr,"error while generating expression;\nsyntax: .generate[ symbol, \"strname\", \"savenameprefix\"\n"));
	oprintf("_Generate( __generate__%s(), %s, %s);\n", (char*) a[0]->data, (char*) a[1]->data, (char*) a[2]->data);
}

static void do_directive(char *name, expression_t *args) {
	if (!strcmp(name,"generate"))
		CLL_INSERT_BEFORE(&toplevels,args);
}


static FILE *input_file;
static char* output_file_name;
static char* source_output_file_name;
static char* temp_directory;
static char *compiler="cc";
static int compargs=0;
static char *compiler_args[20]= {
	"-g", "-o", "%o", "%i", 0 };
static char *exe_file_name;
static int nocompile=0,noexec= 0;

static char *make_temp_file() {
	int i;
	char host[200];
	int r;
	struct stat sbuf;
	gethostname(host, sizeof(host));
	host[sizeof(host)-1]= 0;
	if (!temp_directory) {
		temp_directory=getenv("TMP_DIR");
		if (!temp_directory)
			temp_directory=getenv("HOME");
		if (!temp_directory)
			exit(fprintf(stderr,"%s: either give a temp directory option, or set one of HOME or TMP_DIR\n",prgname));
	}
	i=0;
	while ((r=stat(temp_directory,&sbuf)) && errno==EINTR)
		;
	if (r)
		exit(fprintf(stderr,"%s: can not stat temp directory %s: %s\n",prgname, temp_directory, strerror(errno)));
	while(1) {
		char buf[2000];
		snprintf(buf,sizeof(buf),"%s/rxgen%s-%d-%d.c",temp_directory, host, getpid(), i);
		while ((r=stat(buf,&sbuf)) && errno==EINTR)
			;
		if (r && errno==ENOENT)
			return strdup(buf);
		if (!r)
			i++;
		else
			exit(fprintf(stderr,"%s: while finding a temporary file name in %s: %s\ntry giving one by hand and make sure its name ends with .c\n",prgname,temp_directory,strerror(errno)));
	}
	return 0;
}

int parse_options(int argc,char **argv) {
	OPTIONS_BEGIN
	OPTION( "-o", ARG_STR, "Print the output to the given file instead of stdout" ) {
		output_file_name= arg;
	}
	OPTION( "-s", ARG_STR, "Print the intermediate code to given file") {
		source_output_file_name= arg;
	}
	OPTION( "-x", ARG_STR, "Compile the intermediate program into this file") {
		exe_file_name= arg;
	}
	OPTION( "-t", ARG_STR, "Set the temporary directory for intermediate files") {
		temp_directory= arg;
	}
	OPTION( "-cc", ARG_STR, "Set the compiler") { compiler= arg; }
	OPTION( "-cf", ARG_STR, "Append an argument or flag to the compiler invocation.\n"
				"\t\t%i is the input file %o is the output file.\n"
				"\t\tYou should give this option once for each compiler option") {
		if (compargs==19)
			exit(fprintf(stderr,"%s: too many compiler flags\n",argv[0]));
		compiler_args[compargs++]= arg;
	}
	OPTION( "-nc", ARG_NONE, "Compilation is not done if you give this flag. Only the source is generated") {
		nocompile= 1;
	}
	OPTION( "-nx", ARG_NONE, "Execution is not done if you give this flag. Only the executable is generated") {
		noexec= 1;
	}
	ARG {
		if (input_file)
			exit(fprintf(stderr,"%s: did not understand second argument %s\n",argv[0],arg));
		input_file= fopen(arg,"r");
		if (!input_file)
			exit(fprintf(stderr,"%s: can not open file %s for reading: %s\n", argv[0], arg, strerror(errno)));
	}
	OPTIONS_END
}

int main(int argc,char **argv) {
	prgname= argv[0];
	parse_options(argc,argv);
	if (!input_file)
		input_file= stdin;
	yyin= input_file;
	yyparse();

	if (!source_output_file_name)
		source_output_file_name= make_temp_file();
	output_file= fopen(source_output_file_name, "w");
	if (!output_file)
		exit(fprintf(stderr,"%s: can not open %s for writing: %s\n",argv[0], source_output_file_name, strerror(errno)));

	{
		static const char libdotc[]= {
#include "lib.c.hex"
		0
		};
		oprintf("%s",libdotc);
	}
	print_prototypes();
	print_all_rules();

	if (rest) {
		fwrite(rest->data,1,rest->len,output_file);
	}

	oprintf("int main() {\n");
	{
		expression_t *e;
		for(e=toplevels.next;e!=&toplevels;e=e->next)
			do_generate(e);
	}
	oprintf("	return 0;\n}\n");
	fclose(input_file);
	fclose(output_file);

	if (nocompile)
		return 0;
	{
		int len=0;
		char *buf;
		char *args[22];
		int i;
		if (!exe_file_name)
			exe_file_name= make_temp_file();
		if (compargs==0)
			while(compiler_args[compargs])
				compargs++;
		for(i=0;i<compargs;i++) {
			if (!strcmp(compiler_args[i],"%o"))
				args[i+1]= exe_file_name;
			else if (!strcmp(compiler_args[i],"%i"))
				args[i+1]= source_output_file_name;
			else
				args[i+1]= compiler_args[i];
			len+= strlen(args[i+1])+3;
		}
		args[0]= compiler;
		len+= strlen(compiler)+1;
		buf= malloc(len+1);
		buf[0]= 0;
		for(i=0;i<compargs+1;i++) {
			strcat(buf," ");
			if (i) strcat(buf,"'");
			strcat(buf,args[i]);
			if (i) strcat(buf,"'");
		}
		fprintf(stderr,"%s: executing %s\n",argv[0],buf);
		if (system(buf))
			exit(fprintf(stderr,"%s: compilation failed\n",argv[0]));
	}
	if (noexec)
		return 0;
	if (system(exe_file_name))
		exit(fprintf(stderr,"%s: execution of generator %s failed\n",argv[0],exe_file_name));
	unlink(source_output_file_name);
	unlink(exe_file_name);
	return 0;
}


